=== Components/CMakeLists.txt ===
#---------------------------------------------------------------------
# Sub project name

PROJECT( elxComponents )

#---------------------------------------------------------------------
# Set the libraries to be linked.

# Linux gave an error, if param was linked. This was only
# when we still used .dll's. I'm not sure if it will still
# give an error, but as long as linux does not complain
# about the missing param, just leave it out.
IF( UNIX )
  IF ( NOT APPLE )
    SET(elxLinkLibs
      xoutlib
      elxCommon
      elxCore
      ITKBasicFilters
      ITKNumerics
      ITKIO
      ITKCommon
      ITKStatistics )
  ENDIF( NOT APPLE )
ENDIF( UNIX )

# Interestingly, visual c++ and MAC-GCC do need param
IF( WIN32 OR APPLE )
  SET( elxLinkLibs
    param
    xoutlib
    elxCommon
    elxCore
    ITKBasicFilters
    ITKNumerics
    ITKIO
    ITKCommon
    ITKStatistics )
ENDIF( WIN32 OR APPLE )

#--------------------------------------------------------------------
# Prepare elxInstallComponentFunctionDeclarations.h and
# elxInstallComponentFunctionCalls.h
# In the ADD_ELXCOMPONENT macro a line is added
#

SET( InstallFunctionDeclarationFile
  ${elastix_BINARY_DIR}/elxInstallComponentFunctionDeclarations.h )
SET( InstallFunctionCallFile
  ${elastix_BINARY_DIR}/elxInstallComponentFunctionCalls.h )

FILE( WRITE ${InstallFunctionDeclarationFile}
  "\n" "//This file is generated by CMake. Do not edit manually!\n\n" )
FILE( WRITE ${InstallFunctionCallFile}
  "\n" "//This file is generated by CMake. Do not edit manually!\n\n" )


#---------------------------------------------------------------------
# Macro that simplifies the addition of elx-components
#
# Usage:
# ADD_ELXCOMPONENT( <name_of_lib> <list_of_source_and_header_files> )
#
# The name_of_lib should be equal to the name of the elx class,
# which also should be the name used in the elxInstallMacro, in the
# the .cxx file of the component.
#

MACRO( ADD_ELXCOMPONENT name )
  # Compile this component or not
  SET( defaultValue ON )
  IF( ${ARGV1} STREQUAL "OFF" )
    SET( defaultValue OFF )
  ENDIF()
  MARK_AS_ADVANCED( USE_${name} )
  OPTION( USE_${name} "Compile this component" ${defaultValue} )

  IF( USE_${name} )
    # Create the list of files which create the library
    SET( filelist ${ARGN} )
    LIST( REMOVE_ITEM filelist "ON" "OFF" )

    # Create project and library
    PROJECT( ${name} )
    ADD_LIBRARY( ${name} STATIC ${filelist} )
    TARGET_LINK_LIBRARIES( ${name} ${elxLinkLibs} )

    # Group in IDE's like Visual Studio
    STRING( REGEX MATCH "[a-zA-Z]+" comp_group ${relative_path_to_comp} )
    SET_PROPERTY( TARGET ${name} PROPERTY FOLDER ${comp_group} )

    # Update AllComponentLibs, while avoiding duplicates:
    IF( DEFINED AllComponentLibs )
      SET( dummy ${AllComponentLibs} )
			IF( NOT "${dummy}" STREQUAL "")
			  LIST( REMOVE_ITEM dummy ${name} )
			ENDIF()
      SET( dummy ${dummy} ${name} )
    ELSE()
      SET( dummy ${name} )
    ENDIF()
    SET( AllComponentLibs ${dummy} CACHE INTERNAL "All component libraries for elastix/transformix" )

    # Write lines to two files
    FILE( APPEND ${InstallFunctionDeclarationFile}
      "elxInstallComponentFunctionDeclarationMacro( " ${name} " );\n\n" )
    FILE( APPEND ${InstallFunctionCallFile}
      "elxInstallComponentFunctionCallMacro( " ${name} " );\n\n" )

  ELSE( USE_${name} )
    # Remove from link list
    IF( DEFINED AllComponentLibs )
      SET( dummy ${AllComponentLibs} )
			IF( NOT "${dummy}" STREQUAL "")
        LIST( REMOVE_ITEM dummy ${name} )
			ENDIF()
    ELSE()
      SET( dummy "" )
    ENDIF()
    SET( AllComponentLibs ${dummy} CACHE INTERNAL "All component libraries for elastix/transformix"  )
  ENDIF()

ENDMACRO( ADD_ELXCOMPONENT )

#---------------------------------------------------------------------
# Search for all components
#

# Initialize the list of link libs.
SET( AllComponentLibs "" CACHE INTERNAL "All component libraries for elastix/transformix"  )

FILE( GLOB_RECURSE ListOfComponents "*/CMakeLists.txt" )

FOREACH( component ${ListOfComponents} )
  GET_FILENAME_COMPONENT( path_to_comp ${component} PATH )
  # Make the path relative to the elxComponents_SOURCE_DIR
  STRING( REGEX REPLACE "${elxComponents_SOURCE_DIR}/" "" relative_path_to_comp ${path_to_comp} )
  ADD_SUBDIRECTORY( ${relative_path_to_comp} )
ENDFOREACH()

#----------------------------------------------------------------------
# Search for user components

FOREACH( userComponentDir ${ELASTIX_USER_COMPONENT_DIRS} )

  MESSAGE( STATUS "Searching for user components in: ${userComponentDir}" )
  FILE( GLOB_RECURSE listOfUserComponents "${userComponentDir}/CMakeLists.txt" )

  FOREACH( userComponent ${listOfUserComponents} )

    GET_FILENAME_COMPONENT( pathToComp ${userComponent} PATH )

    # read project name from cmakelists.txt
    MESSAGE( STATUS "Reading: ${userComponent}" )

    # Find the first line that has the following structure:
    # ADD_ELXCOMPONENT(projectname [....]
    # spaces before/after/inbetween are allowed.
    # ADD_ELXCOMPONENT does not have to be capitalized.
    # Commented lines (where the first nonwhite character is a #) are ignored.
    FILE( STRINGS ${userComponent} addElxComponentLine LIMIT_COUNT 1 REGEX
      "^[ \t]*[Aa][Dd][Dd]_[Ee][Ll][Xx][Cc][Oo][Mm][Pp][Oo][Nn][Ee][Nn][Tt][ \t]*[(][ \t]*[^ #\t()]+" )

    # Extract the projectname.
    STRING(REGEX REPLACE
      "^[ \t]*[Aa][Dd][Dd]_[Ee][Ll][Xx][Cc][Oo][Mm][Pp][Oo][Nn][Ee][Nn][Tt][ \t]*[(][ \t]*([^ #\t()]+).*"
      "\\1" componentName "${addElxComponentLine}")

		IF( NOT "${componentName}" STREQUAL "" )
      MESSAGE( STATUS "Found user component: ${componentName}" )

      # For non-subdirectories, the binarydir should be specified. We use the name
  		# of the component for that.
      SET( binaryDir "${elastix_BINARY_DIR}/UserComponents/${componentName}" )

      # Add
  		ADD_SUBDIRECTORY( ${pathToComp} ${binaryDir} )

		ELSE()
      MESSAGE( STATUS "No user component definition found in: ${userComponent}" )
  	ENDIF()

  ENDFOREACH()
ENDFOREACH()
