=== Components/Interpolators/ReducedDimensionBSplineInterpolator/CMakeLists.txt ===

ADD_ELXCOMPONENT( ReducedDimensionBSplineInterpolator
 itkReducedDimensionBSplineInterpolateImageFunction.h
 itkReducedDimensionBSplineInterpolateImageFunction.txx
 elxReducedDimensionBSplineInterpolator.h
 elxReducedDimensionBSplineInterpolator.hxx
 elxReducedDimensionBSplineInterpolator.cxx )
