=== debian/changelog ===
elastix (4.4-2) unstable; urgency=low

  [ Andreas Tille ]
  * debian/control:
    - Fix name of Debian Med team (without '-')
    - Added Vcs fields
    - Fix typo in description
      Closes: #613621
  * Added debian/upstream-metadata.yaml
  * Added debian/watch (Thanks to Paul Wise <pabs@debian.org>
    and Daniel Leidert <daniel.leidert@wgdd.de>)

  [ Steve M. Robbins ]
  * target upload to unstable.

 -- Steve M. Robbins <smr@debian.org>  Mon, 21 Feb 2011 10:30:55 -0600

elastix (4.4-1) experimental; urgency=low

  * New package.  Closes: #607030.

 -- Steve M. Robbins <smr@debian.org>  Mon, 27 Dec 2010 06:01:00 -0600
