=== debian/control ===
Source: elastix
Homepage: http://elastix.isi.uu.nl/
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>
Build-Depends: quilt, debhelper (>= 8), cmake, 
 libinsighttoolkit3-dev (>= 3.20.0-5), libgdcm2-dev, zlib1g-dev, libpng12-dev, libtiff4-dev
Build-Depends-Indep: doxygen, graphviz, texlive-latex-base, texlive-latex-extra, texlive-latex-recommended, ghostscript
Standards-Version: 3.9.1
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/elastix/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/elastix/trunk/?rev=0&sc=0

Package: elastix
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: elastix-doc
Description: toolbox for rigid and nonrigid registration of images
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.

Package: elastix-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: toolbox for rigid and nonrigid registration of images - docs
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.
